import "choerodon-ui/pro/lib/data-set/style";
import _DataSet from "choerodon-ui/pro/lib/data-set";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { createContext, useContext, useEffect, useMemo } from 'react';
import { inject } from 'mobx-react';
import { injectIntl } from 'react-intl';
import { withRouter } from 'react-router-dom';
import some from 'lodash/some';
import useStore from "./useStore";
import ManualDeployDataSet from "./ManualDeployDataSet";
import OptionsDataSet from "../../../stores/OptionsDataSet";
import NetworkDataSet from "./NetworkDataSet";
import PortDataSet from "./PortDataSet";
import PathListDataSet from "./PathListDataSet";
import DomainDataSet from "./DomainDataSet";
import AnnotationDataSet from "./AnnotationDataSet";
import MarketAndVersionOptionsDataSet from "./MarketAndVersionOptionsDataSet";
import MarketServiceOptionsDataSet from "./MarketServiceOptionsDataSet";
var Store = /*#__PURE__*/createContext();
export function useManualDeployStore() {
  return useContext(Store);
}
export var StoreProvider = withRouter(injectIntl(inject('AppState')(function (props) {
  var _props$AppState = props.AppState,
      _props$AppState$curre = _props$AppState.currentMenuType,
      projectId = _props$AppState$curre.projectId,
      organizationId = _props$AppState$curre.organizationId,
      categories = _props$AppState$curre.categories,
      currentServices = _props$AppState.currentServices,
      isSaasList = _props$AppState.isSaasList,
      formatMessage = props.intl.formatMessage,
      children = props.children,
      intlPrefix = props.intlPrefix,
      deployStore = props.deployStore,
      envId = props.envId,
      hasHostDeploy = props.hasHostDeploy,
      random = props.random;
  var deployUseStore = useStore();
  var hasDevops = useMemo(function () {
    return some(categories || [], ['code', 'N_DEVOPS']);
  }, [categories]);
  var hasMarket = useMemo(function () {
    return some(currentServices || [], ['serviceCode', 'market-service']);
  }, [currentServices]);
  var isSaaS = isSaasList && isSaasList[organizationId];
  var envOptionsDs = useMemo(function () {
    return new _DataSet(OptionsDataSet());
  }, []);
  var valueIdOptionsDs = useMemo(function () {
    return new _DataSet(OptionsDataSet());
  }, []);
  var versionOptionsDs = useMemo(function () {
    return new _DataSet(OptionsDataSet());
  }, []);
  var pathListDs = useMemo(function () {
    return new _DataSet(PathListDataSet({
      formatMessage: formatMessage,
      projectId: projectId
    }));
  }, [projectId]);
  var annotationDs = useMemo(function () {
    return new _DataSet(AnnotationDataSet({
      formatMessage: formatMessage
    }));
  }, []);
  var domainDs = useMemo(function () {
    return new _DataSet(DomainDataSet({
      formatMessage: formatMessage,
      projectId: projectId,
      pathListDs: pathListDs,
      annotationDs: annotationDs
    }));
  }, [projectId]);
  var portsDs = useMemo(function () {
    return new _DataSet(PortDataSet({
      formatMessage: formatMessage,
      pathListDs: pathListDs
    }));
  }, []);
  var networkDs = useMemo(function () {
    return new _DataSet(NetworkDataSet({
      formatMessage: formatMessage,
      projectId: projectId,
      portsDs: portsDs,
      pathListDs: pathListDs
    }));
  }, []);
  var marketAndVersionOptionsDs = useMemo(function () {
    return new _DataSet(MarketAndVersionOptionsDataSet(projectId), []);
  });
  var marketServiceOptionsDs = useMemo(function () {
    return new _DataSet(MarketServiceOptionsDataSet(projectId), []);
  });
  var manualDeployDs = useMemo(function () {
    return new _DataSet(ManualDeployDataSet({
      intlPrefix: intlPrefix,
      formatMessage: formatMessage,
      projectId: projectId,
      envOptionsDs: envOptionsDs,
      valueIdOptionsDs: valueIdOptionsDs,
      versionOptionsDs: versionOptionsDs,
      deployStore: deployStore,
      networkDs: networkDs,
      domainDs: domainDs,
      organizationId: organizationId,
      deployUseStore: deployUseStore,
      hasHostDeploy: hasHostDeploy,
      marketAndVersionOptionsDs: marketAndVersionOptionsDs,
      marketServiceOptionsDs: marketServiceOptionsDs,
      hasDevops: hasDevops,
      random: random
    }));
  }, [projectId]);
  useEffect(function () {
    envOptionsDs.transport.read.url = "/devops/v1/projects/".concat(projectId, "/envs/list_by_active?active=true");
    envOptionsDs.query();
    !isSaaS && hasMarket && marketAndVersionOptionsDs.query();
  }, [projectId]);

  var value = _objectSpread(_objectSpread({}, props), {}, {
    manualDeployDs: manualDeployDs,
    portsDs: portsDs,
    networkDs: networkDs,
    pathListDs: pathListDs,
    domainDs: domainDs,
    annotationDs: annotationDs,
    deployUseStore: deployUseStore,
    marketAndVersionOptionsDs: marketAndVersionOptionsDs,
    hasDevops: hasDevops,
    hasMarket: hasMarket,
    isSaaS: isSaaS
  });

  return /*#__PURE__*/React.createElement(Store.Provider, {
    value: value
  }, children);
})));